/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.export;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

/**
 * @author aadrians
 * Nov 15, 2012
 *
 */
public interface ILogCreatorAlgorithm {
	/**
	 * create log from alignment
	 * @param context can be null if no progress is needed
	 * @param logReplayResult
	 * @param log
	 * @param param
	 * @return
	 */
	public XLog extractLog(final PluginContext context, PNRepResult logReplayResult, XLog log, LogCreatorParam param);
	
	/**
	 * Name of the algorithm
	 * @return
	 */
	public String toString();
	
	/**
	 * The algorithm may create a new event class for each type of movement
	 * e.g. move sync of transition A, move model of transition A are two new event classes
	 * @return
	 */
	public boolean isSupportCreateNewEventClassBasedOnMovements();
	
	/**
	 * only possible if create new event class based on movements
	 * @return
	 */
	public boolean isSupportCreateNewEventClassForUnmappedTransitions();
}
