/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.projection;

import java.awt.Dimension;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.swing.JPanel;
import javax.swing.table.DefaultTableModel;

import org.processmining.framework.util.ui.widgets.ProMTable;
import org.processmining.framework.util.ui.widgets.WidgetColors;
import org.processmining.plugins.petrinet.replayresult.PNRepResult;

import com.fluxicon.slickerbox.factory.SlickerFactory;

/**
 * @author aadrians Aug 12, 2012
 * 
 */
public class GlobalStatPanel extends JPanel {
	private static final long serialVersionUID = -469825094120998433L;

	/**
	 * GUI ELEMENTS
	 */
	// info table
	private ProMTable table;
	private DefaultTableModel tableModel;

	public GlobalStatPanel(PNRepResult replayResult) {
		super();
		Map<String, Object> allInfo = replayResult.getInfo();
		if ((allInfo != null) && (allInfo.size() > 0)) {
			Set<Entry<String, Object>> entrySet = replayResult.getInfo().entrySet();

			Object[] columnIdentifier = new Object[] { "Property", "Value" };
			Object[][] info = new Object[entrySet.size()][2];
			int counter = 0;
			for (Entry<String, Object> entry : entrySet) {
				info[counter] = new Object[] { entry.getKey(), entry.getValue() };
				counter++;
			}

			tableModel = new DefaultTableModel() {
				private static final long serialVersionUID = -4303950078200984098L;

				public boolean isCellEditable(int row, int column) {
					return false;
				}
			};
			tableModel.setDataVector(info, columnIdentifier);

			table = new ProMTable(tableModel);
			table.setPreferredSize(new Dimension(400, 200));

			table.doLayout();

			add(table);
		} else {
			add(SlickerFactory.instance().createLabel("No global stats are available"));
		}
		setBackground(WidgetColors.PROPERTIES_BACKGROUND);

	}
}
