/**
 * 
 */
package org.processmining.plugins.pnalignanalysis.visualization.projection.util;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

import org.processmining.plugins.manifestanalysis.visualization.performance.PerformanceConstants;

/**
 * @author aadrians
 * Nov 21, 2012
 *
 */
public class FiveColorsLegendPanel extends JPanel {
	private static final long serialVersionUID = 2194428804018314613L;
	
	private Color[] scaling = new Color[]{PerformanceConstants.GOOD, PerformanceConstants.MEDTOGOOD, PerformanceConstants.MEDIUM, PerformanceConstants.BADTOMEDIUM, PerformanceConstants.BAD};
	private int boxWidth = 30;
	
	public FiveColorsLegendPanel(){
		super();
		setPreferredSize(new Dimension(30 * 5 + 10, 30));
	}

	public FiveColorsLegendPanel(Color[] scaling, int boxWidth){
		super();
		this.scaling = scaling;
		this.boxWidth = boxWidth;
	}

	public void paint(Graphics graphics){
		Graphics2D g = (Graphics2D) graphics;
		
		// draw legend
		int padding = 8;
		int currX=padding;
		int currY=padding;
		Font boldFont = new Font("Sans", Font.BOLD, 12);
		Font normalFont = new Font("Sans", Font.PLAIN, 12);
		FontMetrics fm = graphics.getFontMetrics(boldFont);
		int rowHeight = fm.getHeight() + 2;
		int boxHeight = rowHeight;
		
		currY += rowHeight;
		g.setFont(normalFont);
		g.drawString("Low", currX, currY);
		currX += fm.stringWidth("Low") + 5;
		
		g.setPaint(scaling[0]);
		g.fillRect(currX, currY - boxHeight, boxWidth, boxHeight);
		currX += boxWidth;
		g.setPaint(scaling[1]);
		g.fillRect(currX, currY - boxHeight, boxWidth, boxHeight);
		currX += boxWidth;
		g.setPaint(scaling[2]);
		g.fillRect(currX, currY - boxHeight, boxWidth, boxHeight);
		currX += boxWidth;
		g.setPaint(scaling[3]);
		g.fillRect(currX, currY - boxHeight, boxWidth, boxHeight);
		currX += boxWidth;
		g.setPaint(scaling[4]);
		g.fillRect(currX, currY - boxHeight, boxWidth, boxHeight);
		currX += boxWidth;
		currX += 5;
		
		g.setColor(Color.BLACK);
		g.setFont(normalFont);
		g.drawString("High", currX, currY);
		
	}
}
